//+------------------------------------------------------------------+
//|                                                              rsx |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_minimum -50
#property indicator_maximum +50
#property indicator_level1   30
#property indicator_level2  -30
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    Length  = 14;
extern int    Price   = PRICE_TYPICAL;
extern int    Depth   = 3;
extern double Speed   = 0.5;
extern bool   ShowArrows        = false;
extern string ArrowsIdentifier  = "BlauTSI arrows";
extern double ArrowsUpGap       = 0.75;
extern double ArrowsDownGap     = 1.25;
extern color  ArrowUpColor      = LimeGreen;
extern int    ArrowUpWidth      = 2;
extern int    ArrowUpCode       = 241;
extern color  ArrowDownColor    = PaleVioletRed; 
extern int    ArrowDownWidth    = 2; 
extern int    ArrowDownCode     = 242;

//
//
//
//
//

double rsx[];
double rsxHuu[];
double rsxHud[];
double rsxHdd[];
double rsxHdu[];
double slope[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,rsxHuu); SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1,rsxHud); SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(2,rsxHdd); SetIndexStyle(2, DRAW_HISTOGRAM);
      SetIndexBuffer(3,rsxHdu); SetIndexStyle(3, DRAW_HISTOGRAM);
      SetIndexBuffer(4,rsx);
      SetIndexBuffer(5,slope);
      SetIndexBuffer(6,trend);
         Speed = MathMax(MathMin(1.5,Speed),0.1);
         Depth = MathMax(MathMin(10 ,Depth),1);
         IndicatorShortName("Rsx ("+Length+","+Depth+","+DoubleToStr(Speed,2)+")");
   return(0);
}
int deinit()
{
   int lookForLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i); if (StringSubstr(name,0,lookForLength) == ArrowsIdentifier) ObjectDelete(name);  
      }
      
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrkBuffer[][41];

int start()
{
   int i,r,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);

   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+Length); 
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         if (i==(Bars-1)) { for (int c=1; c<13; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][0]-wrkBuffer[r-1][0];
      double moa = MathAbs(mom);
      for (int k=0; k<Depth; k++)
      {
         int kk = k*4;
            wrkBuffer[r][kk+1] = Kg*mom                + Hg*wrkBuffer[r-1][kk+1];
            wrkBuffer[r][kk+2] = Kg*wrkBuffer[r][kk+1] + Hg*wrkBuffer[r-1][kk+2]; mom =         1.5*wrkBuffer[r][kk+1] - Speed * wrkBuffer[r][kk+2];
            wrkBuffer[r][kk+3] = Kg*moa                + Hg*wrkBuffer[r-1][kk+3];
            wrkBuffer[r][kk+4] = Kg*wrkBuffer[r][kk+3] + Hg*wrkBuffer[r-1][kk+4]; moa = MathAbs(1.5*wrkBuffer[r][kk+3] - Speed * wrkBuffer[r][kk+4]);
      }
      if (moa != 0)
           rsx[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)-50.0; 
      else rsx[i] = 0;
      
      //
      //
      //
      //
      //
      
      rsxHuu[i] = EMPTY_VALUE;
      rsxHud[i] = EMPTY_VALUE;
      rsxHdd[i] = EMPTY_VALUE;
      rsxHdu[i] = EMPTY_VALUE;
      slope[i]  = slope[i+1];
      trend[i]  = trend[i+1];
         if (rsx[i]>rsx[i+1]) slope[i] =  1;
         if (rsx[i]<rsx[i+1]) slope[i] = -1;
         if (rsx[i]>0)        trend[i] =  1;
         if (rsx[i]<0)        trend[i] = -1;
         if (rsx[i]>0)
         if (slope[i]==1)
               rsxHuu[i] = rsx[i];
         else  rsxHud[i] = rsx[i];
         if (rsx[i]<0)
         if (slope[i]==1)
               rsxHdu[i] = rsx[i];
         else  rsxHdd[i] = rsx[i];
         manageArrow(i);
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}

//--------------------------------------------------------------------------------------------------------------------+
//
//--------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      ObjectDelete(ArrowsIdentifier+Time[i]);         
            
      //
      //
      //
      //
      //
           
      if (trend[i] != trend[i+1])
      {
         string name = ArrowsIdentifier+Time[i];
         if (trend[i] == 1)
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-ArrowsUpGap*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,ArrowUpCode);
               ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
               ObjectSet(name,OBJPROP_WIDTH,ArrowUpWidth);
         }
         else
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+ArrowsDownGap*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,ArrowDownCode);
               ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
               ObjectSet(name,OBJPROP_WIDTH,ArrowDownWidth);
         }
      }
   }
}